KDE 4.5 PyKDE API Reference

- KDE's Python API

# ThumbCreator Class Reference

`from PyKDE4.kio import *`

Subclasses: ThumbSequenceCreator

## Detailed Description

This is the baseclass for "thumbnail-plugins" in KDE. Using the class KIO.PreviewJob allows you to generate small images (thumbnails) for any kind of file, where a "ThumbCreator" is available. Have a look at kdebase/kioslave/thumbnail/ for existing ThumbCreators.

What you need to do to create and register a ThumbCreator:

- Inherit from this class and reimplement the create() method to
generate a thumbnail for the given file-path.
- Provide a factory method in your implementation file to instantiate
your plugin, e.g.:

     extern "C"
     {
       KDE_EXPORT ThumbCreator *new_creator()
       {
         return new YourThumbCreator();
       }
     };

Compile your ThumbCreator as a module. The contents of CMakeLists.txt should look something like this, with "filetype" replaced by the type of file this plugin creates thumbnails for:

     project(filetypethumbcreator)

     find_package(KDE4 REQUIRED)
     include (KDE4Defaults)
     include(MacroOptionalAddSubdirectory)

     set(filetypethumbnail_SRCS filetypethumbnail.cpp)

     kde4_add_ui_files(filetypethumbnail_SRCS config.ui )

     kde4_add_plugin(filetypethumbnail ${filetypethumbnail_SRCS})
     target_link_libraries(filetypethumbnail ${KDE4_KIO_LIBS})

     install(TARGETS filetypethumbnail DESTINATION ${PLUGIN_INSTALL_DIR})
     install(FILES filetypethumbcreator.desktop DESTINATION ${SERVICES_INSTALL_DIR})

- Create a file filetypethumbcreator.desktop with the following contents:

     [Desktop Entry]
     Encoding=UTF-8
     Type=Service
     Name=Name of the type of files your ThumbCreator supports
     ServiceTypes=ThumbCreator
     MimeType=application/x-somemimetype;
     CacheThumbnail=true
     X-KDE-Library=yourthumbcreator

You can supply a comma-separated list of mimetypes to the MimeTypes entry, naming all mimetypes your ThumbCreator supports. You can also use simple wildcards, like (where you see [slash], put a /)

                  text[slash]* or image[slash]*.

If your plugin is rather inexpensive (e.g. like the text preview ThumbCreator), you can set CacheThumbnail=false to prevent your thumbnails from being cached on disk.

The following optional property can also be added to the .desktop file:

     ThumbnailerVersion=N

where N is some nonnegative integer. If a cached thumbnail has been created with a previous version of the thumbnailer, then the cached thumbnail will be discarded and a new one will be regenerated. Increase (or define) the version number if and only if old thumbnails need to be regenerated. If no version number is provided, then the version is assumed to be <0.

Baseclass for thumbnail-generating plugins.

## Enumerations
Flags | { None, DrawFrame, BlendIcon }
## Methods
bool | create (self, QString path, int width, int height, QImage img)
ThumbCreator.Flags | flags (self)

## Method Documentation

bool create | ( | self, |
|  | QString | path,
|  | int | width,
|  | int | height,
|  | QImage | img
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Creates a thumbnail Note that the width and height parameters should not be used for scaling. Only plugins that create an image "from scratch", like the TextCreator should directly use the specified size. If the resulting preview is larger than width x height, it will be scaled down.

Parameters:

  | path | the (always local) file path to create a preview for
  | width | maximum width for the preview
  | height | maximum height for the preview
  | img | this image will contain the preview on success

Returns:
  true if preview generation succeeded

ThumbCreator.Flags flags | ( |  | self ) |

The flags of this plugin:

- None nothing special
- DrawFrame a frame should be painted around the preview
- BlendIcon the mimetype icon should be blended over the preview

Returns:
  flags for this plugin

## Enumeration Documentation

Flags

The flags of this plugin.

See also:
  flags()

Enumerator:

  None = 0 |
  DrawFrame = 1 |
  BlendIcon = 2 |